<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="申请组织GUID" prop="applOrgGuid">
        <el-input v-model="queryParams.applOrgGuid" placeholder="请输入申请组织GUID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="申请类型" prop="applType">
        <el-select v-model="queryParams.applType" placeholder="请选择申请类型" clearable>
          <el-option v-for="dict in ttsa_appl_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="申请情况" prop="applSituStat">
        <el-select v-model="queryParams.applSituStat" placeholder="请选择申请情况" clearable>
          <el-option v-for="dict in ttsa_appl_situ" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['ttsa:ttsaapplwiun:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['ttsa:ttsaapplwiun:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['ttsa:ttsaapplwiun:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['ttsa:ttsaapplwiun:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="ttsa-ttsaapplwiun-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="申请组织GUID" prop="applOrgGuid" />
      <el-table-column label="单位账号" prop="orgAccount" />
      <el-table-column label="联系人电话" prop="contaPersTel" />
      <el-table-column label="申请类型" prop="applType" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_appl_type" :value="scope.row.applType" />
        </template>
      </el-table-column>
      <el-table-column label="申请情况" prop="applSituStat" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_appl_situ" :value="scope.row.applSituStat" />
        </template>
      </el-table-column>
      <el-table-column label="核验时间" prop="veriTime" width="180" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ttsa:ttsaapplwiun:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ttsa:ttsaapplwiun:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="650px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="申请组织GUID" prop="applOrgGuid">
          <el-input v-model="form.applOrgGuid" placeholder="请输入申请组织GUID" />
        </el-form-item>
        <el-form-item label="单位账号" prop="orgAccount">
          <el-input v-model="form.orgAccount" placeholder="请输入单位账号" />
        </el-form-item>
        <el-form-item label="联系人电话" prop="contaPersTel">
          <el-input v-model="form.contaPersTel" placeholder="请输入联系人电话" />
        </el-form-item>
        <el-form-item label="邮政编码" prop="postCode">
          <el-input v-model="form.postCode" placeholder="请输入邮政编码" />
        </el-form-item>
        <el-form-item label="联系人邮箱" prop="contaPersEmail">
          <el-input v-model="form.contaPersEmail" placeholder="请输入联系人邮箱" />
        </el-form-item>
        <el-form-item label="申请类型" prop="applType">
          <el-select v-model="form.applType" placeholder="请选择申请类型">
            <el-option v-for="dict in ttsa_appl_type" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="申请情况" prop="applSituStat">
          <el-select v-model="form.applSituStat" placeholder="请选择申请情况">
            <el-option v-for="dict in ttsa_appl_situ" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="核验组织GUID" prop="veriOrgGuid">
          <el-input v-model="form.veriOrgGuid" placeholder="请输入核验组织GUID" />
        </el-form-item>
        <el-form-item label="核验时间" prop="veriTime">
          <el-date-picker v-model="form.veriTime" type="datetime" placeholder="选择核验时间" clearable />
        </el-form-item>
        <el-form-item label="核验意见" prop="veriOpin">
          <el-input v-model="form.veriOpin" type="textarea" placeholder="请输入核验意见" />
        </el-form-item>
        <el-form-item label="组织来源" prop="orgSource">
          <el-input v-model="form.orgSource" placeholder="请输入组织来源" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TtsaApplWiun">
import { listBisTtsaApplWiun, getBisTtsaApplWiun, addBisTtsaApplWiun, updateBisTtsaApplWiun, delBisTtsaApplWiun } from "@/api/slaj/ttsa";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { ttsa_appl_type, ttsa_appl_situ } = proxy.useDict("ttsa_appl_type", "ttsa_appl_situ");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ applOrgGuid: { visible: true }, orgAccount: { visible: true }, contaPersTel: { visible: true }, applType: { visible: true }, applSituStat: { visible: true }, veriTime: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, applOrgGuid: null, applType: null, applSituStat: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisTtsaApplWiun(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加申请安全元素";
}

function handleUpdate(row) {
  reset();
  getBisTtsaApplWiun(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改申请安全元素";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisTtsaApplWiun(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisTtsaApplWiun(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisTtsaApplWiun(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/ttsa/ttsaapplwiun/export', { ...queryParams.value }, `申请安全元素_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, applOrgGuid: null, orgAccount: null, contaPersTel: null, postCode: null, contaPersEmail: null, applType: null, applSituStat: null, veriOrgGuid: null, veriTime: null, veriOpin: null, orgSource: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
